*smoking model

cd "/Users/phule2311/Box Sync/Quantitative Methods I/Lecture Notes/"

use SMOKE.dta, clear

log using SMOKE.smcl, replace

sum

*LPM

reg SMOKE sex price

eststo m1

*Logit

logit SMOKE sex price

eststo m2

*Probit

probit SMOKE sex price

eststo m3

*Table out

esttab m1 m2 m3, cells(b(star fmt(4)) se(par fmt(4))) ///
legend varlabels(_cons Constant) ///
title(Regression Results) mtitles("LPM" "Logit" "Probit") nonumbers

**Calculate marginal effect, for male, and at the mean price, Logit
sum price

scalar mprice = r(mean)

logit SMOKE sex price

scalar xb = (_b[sex] + _b[price]*mprice + _b[_cons])

di "Marginal effects at mean price, for male, Logit " _n exp(xb)/(1+exp(xb))^2*_b[price]

*Stata command:

mfx, at(mean sex=1)

*Calculate male and female difference, at the mean price

scalar xb0 = _b[price]*mprice + _b[_cons]

scalar G0 = exp(xb0)/(1+exp(xb0))

scalar xb1 = _b[sex] + _b[price]*mprice + _b[_cons]

scalar G1 = exp(xb1)/(1+exp(xb1))

di "Male-Female difference, at mean price, Logit " _n G1 - G0

*Stata command:

mfx, at(mean sex = 1)


**Calculate marginal effect, for male, and at the mean price, Probit

scalar pi = c(pi) 	// create pi = 3.141592

probit SMOKE sex price

scalar xb = (_b[sex] + _b[price]*mprice + _b[_cons])

di "Marginal effects at mean price, for male, Probit " _n 1/sqrt(2*pi)*exp(-xb^2/2)*_b[price]

*Stata command:

mfx, at(mean sex=1)

*Calculate male and female difference, at the mean price

scalar xb0 = _b[price]*mprice + _b[_cons]

scalar Phi0 = normal(xb0)

scalar xb1 = _b[sex] + _b[price]*mprice + _b[_cons]

scalar Phi1 = normal(xb1)

di "Male-Female difference, at mean price, Probit " _n Phi1 - Phi0

*Stata command:

mfx, at(mean sex=1)

**Prediction
logit SMOKE sex price
predict p, pr
di "Correct prediction of smokers"
count if p>0.5 & SMOKE==1
count if SMOKE == 1
di "Correct prediction of non-smokers"
count if p<0.5 & SMOKE==0
count if SMOKE == 0

di "Percent correctly predicted (Logit) = " 497/807

drop p

*LPM
reg SMOKE sex price
predict p, xb
di "Correct prediction of smokers"
count if p>0.5 & SMOKE==1
count if SMOKE == 1
di "Correct prediction of non-smokers"
count if p<0.5 & SMOKE==0
count if SMOKE == 0

di "Percent correctly predicted (LPM) = " 497/807

*Stata command:
logit SMOKE sex price

estat classification

probit SMOKE sex price

estat classification

**Hypothesis test

*manual LR test
logit SMOKE sex price
scalar lu = e(ll)

logit SMOKE sex
scalar lr = e(ll)

scalar Chi2stat = 2*(lu - lr)

di "Chi2-stat = " Chi2stat
di "p-value = " chi2tail(1, Chi2stat)

*Stata command
logit SMOKE sex price
test price

*alternative method
logit SMOKE sex price
eststo U

logit SMOKE sex
eststo R

lrtest U R

clear

log close
